/*
 * Arpalab.h
 *
 *  Created on: 26/10/2015
 *      Author: Victor Mora
 */

#ifndef __ARPALAB_H_
#define __ARPALAB_H_


/**  Arpalab start Wifly driver and connection parameters.
 *
 * @param ssid SSID connection name.
 * @param AuthMode Authentication mode number.
 * @param passw Pass phrase of the connection.
 *
 * @return Returns whether the initialisation was successful. SUCCESS = TRUE, ERROR = FALSE.
 */
uint8_t Arpalab_start(char *ssid, uint32_t AuthMode, char *passw);

/** Send a HTTP command and receive the server response.
 *
 * @param dnsAddress Destination DNS or IP address.
 * @param id Information id.
 * @param app Name of the app.
 * @param value Numerical value to send.
 *
 * @return Returns whether the transmission was successful. SUCCESS = TRUE, ERROR = FALSE.
 */
uint8_t Arpalab_sendValue( char *dnsAddress, uint32_t id, char *app, uint32_t value);

/** Send a HTTP command an Get a random value.
 *
 * @param dnsAddress Destination DNS or IP address.
 *
 * @return Returns whether the transmission was successful. SUCCESS = TRUE, ERROR = FALSE.
 */
int32_t Arpalab_receiveValue( char *dnsAddress);


#endif /* ARPALAB_H_ */
