/*
 * Tcp.h
 *
 *  Created on: 15/12/2015
 *      Author: Victor Mora
 */

#ifndef TCP_H_
#define TCP_H_


/** Initialise a TCP connection parameters.
 *
 * @param ssid SSID connection name.
 * @param AuthMode authentication mode number.
 * @param passw pass phrase of the connection.
 *
 * @return Returns whether the initialisation was successful. SUCCESS = TRUE, ERROR = FALSE.
 */
uint8_t Tcp_start(char *ssid, uint32_t AuthMode, char *passw);

/**  Send a TCP command and send the server response.
 *
 * @param ipAddress destination IP address.
 * @param remotePort remote port number.
 * @param value numerical value to send.
 *
 * @return Returns whether the transmission was successful. SUCCESS = TRUE, ERROR = FALSE.
 */
uint8_t Tcp_sendValue( char *ipAddress, uint32_t remotePort, uint32_t value);

/** Send a TCP command and receive the server response.
 *
 * @param address destination IP address.
 * @param remotePort remote port number.
 *
 * @return Returns whether the transmission was successful. SUCCESS = TRUE, ERROR = FALSE.
 */
int32_t Tcp_receiveValue( char *address, uint32_t remotePort);

#endif /* TCP_H_ */
