/*
 * Arpalab.c
 *
 *  Created on: 26/10/2015
 *      Author: Victor
 */

#include "LPC17xx.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Type.h"
#include "Config.h"

#include "WiFly.h"
#include "Arpalab.h"
#include "FreeRTOS.h"
#include "semphr.h"


#define GET_SEND "GET$/rest/stats?nid=%d&ip=%s&app=%s&data=%d"
#define GET_RECEIVE "GET$/rest/feed"

#define IP_REMOTE 80
#define IP_PROTO 18
#define BUFSIZE (BUFSIZE_WIFLY)

xSemaphoreHandle xMutexArpalab;
static char *Arpalabssid;
static char *ArpalabPasw;
static uint32_t ArpalabAuthMode;
char resp[BUFSIZE];



/** Start Arpalab settings
 *
 * @param ssid SSID name.
 * @param AuthMode Authentication mode:
 * @param passw password
 * @return TRUE, FALSE
 */
uint8_t Arpalab_start(char *ssid, uint32_t AuthMode, char *passw)
{
	uint8_t rtn= FALSE;
	if( xMutexArpalab == NULL )
	{
		xMutexArpalab = xSemaphoreCreateMutex();
	}
	/*Use semaphore to start driver */
	xSemaphoreTakeRecursive( xMutexArpalab, portMAX_DELAY );
	{
		Arpalabssid = ssid;
		ArpalabAuthMode =AuthMode;
		ArpalabPasw= passw;
	}
	xSemaphoreGiveRecursive( xMutexArpalab );

	return rtn;
}

uint8_t Arpalab_sendValue( char *dnsAddress, uint32_t id, char *app, uint32_t value)
{
	uint8_t rtn= FALSE;
	char commRemote[128];
	char *ip;

	xSemaphoreTakeRecursive( xMutexArpalab, portMAX_DELAY );
	{
		Wifly_WLANConnectPing(ArpalabAuthMode, Arpalabssid, ArpalabPasw, WLAN_PING_CHECK);
		ip=Wifly_getIp();
		sprintf(commRemote,GET_SEND,id, ip, app, value);
		rtn= Wifly_HTTPSend(dnsAddress, commRemote, IP_REMOTE, IP_PROTO);
	}
	xSemaphoreGiveRecursive( xMutexArpalab );

	return rtn;
}

int32_t Arpalab_receiveValue( char *dnsAddress)
{
	int32_t value;
	char *string;

	xSemaphoreTakeRecursive( xMutexArpalab, portMAX_DELAY );
	{
		Wifly_WLANConnectPing(ArpalabAuthMode, Arpalabssid, ArpalabPasw, WLAN_PING_CHECK);
		string=strcpy(resp,Wifly_HTTPReceive(dnsAddress, GET_RECEIVE, IP_REMOTE, IP_PROTO));
		string=strstr(string, "\r\n\r\n") + strlen("\r\n\r\n");
		value = strtol(string , &string, 10);
	}
	xSemaphoreGiveRecursive( xMutexArpalab );

	return value;
}

